package cat.ximpleries.beerradar;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * ****** Adapter class extends with BaseAdapter and implements with OnClickListener ***********
 */
public class BeerAdapter extends BaseAdapter implements View.OnClickListener {

    private static LayoutInflater inflater = null;
    BeerModel tempValues = null;
    int i = 0;
    private Activity activity;
    private ArrayList<BeerModel> data;

    public BeerAdapter(Activity a, ArrayList d) {

        /********** Take passed values **********/
        activity = a;
        data = d;

        /***********  Layout inflator to call external xml layout () ***********/
        inflater = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public int getCount() {
        if (data.size() <= 0)
            return 1;
        return data.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {

        View vi = convertView;
        ViewHolder holder;

        if (convertView == null) {

            vi = inflater.inflate(R.layout.beer_row, null);

            holder = new ViewHolder();
            holder.beerName = (TextView) vi.findViewById(R.id.beerName);
            holder.brewery = (TextView) vi.findViewById(R.id.brewery);
            holder.beerStyle = (TextView) vi.findViewById(R.id.beerStyle);
            holder.image = (ImageView) vi.findViewById(R.id.beerImage);

            vi.setTag(holder);
        } else
            holder = (ViewHolder) vi.getTag();

        if (data.size() <= 0) {
        } else {
            tempValues = data.get(position);

            holder.brewery.setText(tempValues.getCerveseria());
            holder.beerName.setText(tempValues.getNom());
            holder.beerStyle.setText(tempValues.getEstil());

            HashMap<String, Bitmap> imgCache = Updater.getInstance(this.activity).bitmaps;
            if (imgCache.containsKey(tempValues.getImageUrl())) {
                int[] newWH = Updater.getMaxDimensions(imgCache.get(tempValues.getImageUrl()), 150);
                Bitmap scaled = Bitmap.createScaledBitmap(imgCache.get(tempValues.getImageUrl()), newWH[0], newWH[1], true);
                holder.image.setImageBitmap(scaled);
            } else {
                new Updater.DownloadImageTask(holder.image, 150).execute(tempValues.getImageUrl());
            }

            vi.setOnClickListener(new OnItemClickListener(position));
        }
        return vi;
    }

    @Override
    public void onClick(View v) {
        Log.v("CustomAdapter", "=====Row button clicked=====");
    }

    /**
     * ****** Create a holder Class to contain inflated xml file elements ********
     */
    public static class ViewHolder {

        public TextView brewery;
        public TextView beerName;
        public ImageView image;
        public TextView beerStyle;
    }

    /**
     * ****** Called when Item click in ListView ***********
     */
    private class OnItemClickListener implements View.OnClickListener {
        private int mPosition;

        OnItemClickListener(int position) {
            mPosition = position;
        }

        @Override
        public void onClick(View arg0) {
            MainActivity mact = (MainActivity) activity;

            //  Call  onItemClick Method inside MainActivity Class
            if(mPosition >=0 && mPosition < data.size())
                mact.displayBeerDetails(data.get(mPosition).getIdCervesa());
        }
    }
}
