package cat.ximpleries.beerradar;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;

/**
 * ****** Adapter class extends with BaseAdapter and implements with OnClickListener ***********
 */
public class CommentsAdapter extends BaseAdapter implements View.OnClickListener {

    private static LayoutInflater inflater = null;
    CommentModel tempValues = null;
    int i = 0;
    private Activity activity;
    private ArrayList<CommentModel> data;

    public CommentsAdapter(Activity a, ArrayList d) {
        activity = a;
        data = d;
        inflater = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public int getCount() {
        if (data.size() <= 0)
            return 1;
        return data.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) {

        View vi = convertView;
        ViewHolder holder;

        if (convertView == null) {

            vi = inflater.inflate(R.layout.comments_row, null);

            holder = new ViewHolder();
            holder.pubUser = (TextView) vi.findViewById(R.id.publicacioUsr);
            holder.pubComment = (TextView) vi.findViewById(R.id.publicacioTxt);
            holder.pubData = (TextView) vi.findViewById(R.id.publicacioData);
            holder.pubAvatar = (ImageView) vi.findViewById(R.id.publicacioAvatar);
            holder.pubBeer = (TextView) vi.findViewById(R.id.publicacioCervesa);

            vi.setTag(holder);
        } else
            holder = (ViewHolder) vi.getTag();

        if (data.size() <= 0) {
        } else {
            tempValues = data.get(position);

            holder.pubComment.setText(tempValues.getComentari());
            holder.pubData.setText(tempValues.getData());
            holder.pubUser.setText(tempValues.getNom_usuari());
            holder.pubAvatar.setImageDrawable(activity.getResources().getDrawable(Profile.avatarIdToDrawable(tempValues.getAvatar_id())));
            holder.pubBeer.setText(tempValues.getNomCervesa());
        }
        return vi;
    }

    @Override
    public void onClick(View v) {
    }

    public static class ViewHolder {
        public TextView pubUser;
        public TextView pubData;
        public ImageView pubAvatar;
        public TextView pubComment;
        public TextView pubBeer;
    }
}
