package cat.ximpleries.beerradar;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * ****** Adapter class extends with BaseAdapter and implements with OnClickListener ***********
 */
public class NewsAdapter extends BaseAdapter implements View.OnClickListener {

    private static LayoutInflater inflater = null;
    NewsModel tempValues = null;
    int i = 0;
    private Activity activity;
    private ArrayList data;

    public NewsAdapter(Activity a, ArrayList d) {

        /********** Take passed values **********/
        activity = a;
        data = d;

        /***********  Layout inflator to call external xml layout () ***********/
        inflater = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public int getCount() {
        if (data.size() <= 0)
            return 1;
        return data.size();
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    /**
     * *** Depends upon data size called for each row , Create each ListView row ****
     */
    public View getView(int position, View convertView, ViewGroup parent) {

        View vi = convertView;
        ViewHolder holder;

        if (convertView == null) {

            /****** Inflate tabitem.xml file for each row ( Defined below ) *******/
            vi = inflater.inflate(R.layout.news_row, null);

            /****** View Holder Object to contain tabitem.xml file elements ******/

            holder = new ViewHolder();
            holder.date = (TextView) vi.findViewById(R.id.beerName);
            holder.title = (TextView) vi.findViewById(R.id.brewery);
            holder.image = (ImageView) vi.findViewById(R.id.beerImage);

            /************  Set holder with LayoutInflater ************/
            vi.setTag(holder);
        } else
            holder = (ViewHolder) vi.getTag();

        if (data.size() <= 0) {
        } else {
            tempValues = (NewsModel) data.get(position);

            /************  Set Model values in Holder elements ***********/
            // Multiple lines solution as seen in http://stackoverflow.com/questions/18693285/how-to-let-a-textview-have-multiple-lines
            holder.title.setText(Html.fromHtml(tempValues.getTitle()));
            holder.date.setText(Html.fromHtml(tempValues.getDate()));

            HashMap<String, Bitmap> imgCache = Updater.getInstance(this.activity).bitmaps;
            if (imgCache.containsKey(tempValues.getImageUrl())) {
                int[] newWH = Updater.getMaxDimensions(imgCache.get(tempValues.getImageUrl()), 175);
                Bitmap scaled = Bitmap.createScaledBitmap(imgCache.get(tempValues.getImageUrl()), newWH[0], newWH[1], true);
                holder.image.setImageBitmap(scaled);
            } else {
                new Updater.DownloadImageTask(holder.image, 175).execute(tempValues.getImageUrl());
            }

            /******** Set Item Click Listner for LayoutInflater for each row *******/

            vi.setOnClickListener(new OnItemClickListener(position));
        }
        return vi;
    }

    @Override
    public void onClick(View v) {
        Log.v("CustomAdapter", "=====Row button clicked=====");
    }

    /**
     * ****** Create a holder Class to contain inflated xml file elements ********
     */
    public static class ViewHolder {

        public TextView title;
        public TextView date;
        public ImageView image;

    }

    /**
     * ****** Called when Item click in ListView ***********
     */
    private class OnItemClickListener implements View.OnClickListener {
        private int mPosition;

        OnItemClickListener(int position) {
            mPosition = position;
        }

        @Override
        public void onClick(View arg0) {
            MainActivity mact = (MainActivity) activity;

            //  Call  onItemClick Method inside MainActivity Class
            mact.displayNewsDetails(mPosition);
        }
    }
}
