package cat.ximpleries.beerradar;

import android.app.Activity;
import android.graphics.drawable.Drawable;

/**
 * Created by Lluis2 on 06.06.2015.
 */
public class Profile {
    private int selectedAvatar;
    private int userAvatarId;
    private Drawable avatar;
    private String userName;
    private Activity activity;

    Profile(Activity activity) {
        this.activity = activity;
    }

    public static int avatarIdToDrawable(int avatarId) {
        switch (avatarId) {
            case 0:
                return R.drawable.a00;
            case 1:
                return R.drawable.a02;
            case 2:
                return R.drawable.a03;
            case 3:
                return R.drawable.a04;
            case 4:
                return R.drawable.a05;
            case 5:
                return R.drawable.b01;
            case 6:
                return R.drawable.b02;
            case 7:
                return R.drawable.b03;
            case 8:
                return R.drawable.b04;
            case 9:
                return R.drawable.b05;
            case 10:
                return R.drawable.c01;
            case 11:
                return R.drawable.c02;
            case 12:
                return R.drawable.c03;
            case 13:
                return R.drawable.c04;
            case 14:
                return R.drawable.c05;
            case 15:
                return R.drawable.d01;
            case 16:
                return R.drawable.d02;
            case 17:
                return R.drawable.d03;
            case 18:
                return R.drawable.d04;
            case 19:
                return R.drawable.d05;
            case 20:
                return R.drawable.e01;
            case 21:
                return R.drawable.e02;
            case 22:
                return R.drawable.e03;
            case 23:
                return R.drawable.e04;
            case 24:
                return R.drawable.e05;
            case 25:
                return R.drawable.f01;
            case 26:
                return R.drawable.f02;
            case 27:
                return R.drawable.f03;
            case 28:
                return R.drawable.f04;
            case 29:
                return R.drawable.f05;
            case 30:
                return R.drawable.g01;
            case 31:
                return R.drawable.g02;
            case 32:
                return R.drawable.g03;
            case 33:
                return R.drawable.g04;
            case 34:
                return R.drawable.g05;
            case 35:
                return R.drawable.h01;
            case 36:
                return R.drawable.h02;
            case 37:
                return R.drawable.h03;
            case 38:
                return R.drawable.h04;
            case 39:
                return R.drawable.h05;
            case 40:
                return R.drawable.l01;
            case 41:
                return R.drawable.l02;
            case 42:
                return R.drawable.l03;
            case 43:
                return R.drawable.l04;
            case 44:
                return R.drawable.l05;
            case 45:
                return R.drawable.m01;
            case 46:
                return R.drawable.m02;
            case 47:
                return R.drawable.m03;
            case 48:
                return R.drawable.m04;
            case 49:
                return R.drawable.m05;
            case 50:
                return R.drawable.n01;
            case 51:
                return R.drawable.n02;
            case 52:
                return R.drawable.n03;
            case 53:
                return R.drawable.n04;
            case 54:
                return R.drawable.n05;
            case 55:
                return R.drawable.fa01;
            case 56:
                return R.drawable.fa02;
            case 57:
                return R.drawable.fa03;
            case 58:
                return R.drawable.fa04;
            case 59:
                return R.drawable.fa05;
            case 60:
                return R.drawable.fb01;
            case 61:
                return R.drawable.fb02;
            case 62:
                return R.drawable.fb03;
            case 63:
                return R.drawable.fb04;
            case 64:
                return R.drawable.fb05;
            case 65:
                return R.drawable.fc01;
            case 66:
                return R.drawable.fc02;
            case 67:
                return R.drawable.fc03;
            case 68:
                return R.drawable.fc04;
            case 69:
                return R.drawable.fc05;
            case 70:
                return R.drawable.fd01;
            case 71:
                return R.drawable.fd02;
            case 72:
                return R.drawable.fd03;
            case 73:
                return R.drawable.fd04;
            case 74:
                return R.drawable.fd05;
            case 75:
                return R.drawable.fe01;
            case 76:
                return R.drawable.fe02;
            case 77:
                return R.drawable.fe03;
            case 78:
                return R.drawable.fe04;
            case 79:
                return R.drawable.fe05;
            case 80:
                return R.drawable.fg01;
            case 81:
                return R.drawable.fg02;
            case 82:
                return R.drawable.fg03;
            case 83:
                return R.drawable.fg04;
            case 84:
                return R.drawable.fg05;
            case 85:
                return R.drawable.fh01;
            case 86:
                return R.drawable.fh02;
            case 87:
                return R.drawable.fh03;
            case 88:
                return R.drawable.fh04;
            case 89:
                return R.drawable.fh05;
            case 90:
                return R.drawable.fi01;
            case 91:
                return R.drawable.fi02;
            case 92:
                return R.drawable.fi03;
            case 93:
                return R.drawable.fi04;
            case 94:
                return R.drawable.fi05;
            default:
                return R.drawable.generic_user;
        }
    }

    public static int buttonIdToAvatarId(int buttonId) {
        int i = 0;
        switch (buttonId) {
            case R.id.avatar_a00:
                return 0;
            case R.id.avatar_a02:
                return 1;
            case R.id.avatar_a03:
                return 2;
            case R.id.avatar_a04:
                return 3;
            case R.id.avatar_a05:
                return 4;
            case R.id.avatar_b01:
                return 5;
            case R.id.avatar_b02:
                return 6;
            case R.id.avatar_b03:
                return 7;
            case R.id.avatar_b04:
                return 8;
            case R.id.avatar_b05:
                return 9;
            case R.id.avatar_c01:
                return 10;
            case R.id.avatar_c02:
                return 11;
            case R.id.avatar_c03:
                return 12;
            case R.id.avatar_c04:
                return 13;
            case R.id.avatar_c05:
                return 14;
            case R.id.avatar_d01:
                return 15;
            case R.id.avatar_d02:
                return 16;
            case R.id.avatar_d03:
                return 17;
            case R.id.avatar_d04:
                return 18;
            case R.id.avatar_d05:
                return 19;
            case R.id.avatar_e01:
                return 20;
            case R.id.avatar_e02:
                return 21;
            case R.id.avatar_e03:
                return 22;
            case R.id.avatar_e04:
                return 23;
            case R.id.avatar_e05:
                return 24;
            case R.id.avatar_f01:
                return 25;
            case R.id.avatar_f02:
                return 26;
            case R.id.avatar_f03:
                return 27;
            case R.id.avatar_f04:
                return 28;
            case R.id.avatar_f05:
                return 29;
            case R.id.avatar_g01:
                return 30;
            case R.id.avatar_g02:
                return 31;
            case R.id.avatar_g03:
                return 32;
            case R.id.avatar_g04:
                return 33;
            case R.id.avatar_g05:
                return 34;
            case R.id.avatar_h01:
                return 35;
            case R.id.avatar_h02:
                return 36;
            case R.id.avatar_h03:
                return 37;
            case R.id.avatar_h04:
                return 38;
            case R.id.avatar_h05:
                return 39;
            case R.id.avatar_l01:
                return 40;
            case R.id.avatar_l02:
                return 41;
            case R.id.avatar_l03:
                return 42;
            case R.id.avatar_l04:
                return 43;
            case R.id.avatar_l05:
                return 44;
            case R.id.avatar_m01:
                return 45;
            case R.id.avatar_m02:
                return 46;
            case R.id.avatar_m03:
                return 47;
            case R.id.avatar_m04:
                return 48;
            case R.id.avatar_m05:
                return 49;
            case R.id.avatar_n01:
                return 50;
            case R.id.avatar_n02:
                return 51;
            case R.id.avatar_n03:
                return 52;
            case R.id.avatar_n04:
                return 53;
            case R.id.avatar_n05:
                return 54;
            case R.id.avatar_fa01:
                return 55;
            case R.id.avatar_fa02:
                return 56;
            case R.id.avatar_fa03:
                return 57;
            case R.id.avatar_fa04:
                return 58;
            case R.id.avatar_fa05:
                return 59;
            case R.id.avatar_fb01:
                return 60;
            case R.id.avatar_fb02:
                return 61;
            case R.id.avatar_fb03:
                return 62;
            case R.id.avatar_fb04:
                return 63;
            case R.id.avatar_fb05:
                return 64;
            case R.id.avatar_fc01:
                return 65;
            case R.id.avatar_fc02:
                return 66;
            case R.id.avatar_fc03:
                return 67;
            case R.id.avatar_fc04:
                return 68;
            case R.id.avatar_fc05:
                return 69;
            case R.id.avatar_fd01:
                return 70;
            case R.id.avatar_fd02:
                return 71;
            case R.id.avatar_fd03:
                return 72;
            case R.id.avatar_fd04:
                return 73;
            case R.id.avatar_fd05:
                return 74;
            case R.id.avatar_fe01:
                return 75;
            case R.id.avatar_fe02:
                return 76;
            case R.id.avatar_fe03:
                return 77;
            case R.id.avatar_fe04:
                return 78;
            case R.id.avatar_fe05:
                return 79;
            case R.id.avatar_fg01:
                return 80;
            case R.id.avatar_fg02:
                return 81;
            case R.id.avatar_fg03:
                return 82;
            case R.id.avatar_fg04:
                return 83;
            case R.id.avatar_fg05:
                return 84;
            case R.id.avatar_fh01:
                return 85;
            case R.id.avatar_fh02:
                return 86;
            case R.id.avatar_fh03:
                return 87;
            case R.id.avatar_fh04:
                return 88;
            case R.id.avatar_fh05:
                return 89;
            case R.id.avatar_fi01:
                return 90;
            case R.id.avatar_fi02:
                return 91;
            case R.id.avatar_fi03:
                return 92;
            case R.id.avatar_fi04:
                return 93;
            case R.id.avatar_fi05:
                return 94;
            default:
                return -1;
        }
    }

    public int getSelectedAvatar() {
        return selectedAvatar;
    }

    public void setSelectedAvatar(int selectedAvatar) {
        this.selectedAvatar = selectedAvatar;
    }

    public int getUserAvatarId() {
        return userAvatarId;
    }

    public void setUserAvatar(int userAvatarId) {
        this.userAvatarId = userAvatarId;
        try {
            this.avatar = activity.getResources().getDrawable(avatarIdToDrawable(userAvatarId));
        } catch (Throwable t) {
            this.avatar = activity.getResources().getDrawable(R.drawable.generic_user);
        }
    }

    public Drawable getAvatar() {
        return avatar;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }
}
